<?php

const ENABLE_CACHE = true;

if (is_bot() || 1 == 1) {
    $cache_path = __DIR__ . '/../static-files';
        
    if (!is_dir($cache_path)) {
        mkdir($cache_path, 0777, true);
    }

    render_static();
} else {
    $GLOBALS['s'] = microtime(true);
    render_dynamic();
}

function render_dynamic()
{
    $path = path();

    $appsList = APPS_LIST;

    foreach ($appsList as $appPath => $fileToRender) {
        if (strpos($path, $appPath) === 0) {
             require $fileToRender;
             die;
        }
    }
}

function path() 
{
    static $path;
    
    if (! $path) {
        $path = ltrim($_GET['path'] ?? $_SERVER['REQUEST_URI'], '/');
        // for arabic letters and utf8 in general
        $path = urldecode($path);        
    }

    return '/' . $path;
}

function is_bot() {
    return  preg_match('/rambler|abacho|acoi|accona|aspseek|altavista|estyle|scrubby|lycos|geona|ia_archiver|Google-Site-Verification|Googlebot|facebook|crawl|WhatsApp|alexa|sogou|skype|facebook|twitter|pinterest|linkedin|naver|bing|google|yahoo|duckduckgo|yandex|baidu|teoma|xing|java\/1.7.0_45|bot|crawl|slurp|spider|mediapartners|\sask\s|\saol\s/i', $_SERVER['HTTP_USER_AGENT']);
}

function cacher()
{
    static $cache;
    
    if (! ENABLE_CACHE) return;

    if (! $cache) {
        $cache = new Redis();
        $cache->connect('localhost', 6379);        
    }

    return $cache;
}

function cache($content) 
{
    if (! ENABLE_CACHE) return;

    cacher()->set(cacheKey(), $content);
}

function render_static() 
{
    $cache = cacher();

    if ($content = $cache->get($cacheKey = cacheKey())) {
        die($content);
    }

    if (file_exists($file_path = cache_file_path())) {
        $content = file_get_contents($file_path);
    
        cache($content);
    
        echo $content;
        die;
    } else {
        load_content();
    }    
}

function cache_file_path() 
{    
    global $cache_path;

    $file_path = $cache_path . '/' . cacheKey() . '.html';

    return $file_path;
}

function cacheKey()
{
    global $cache_path;

    $path = path();
    
    $fileName = $path;

    if (!$fileName || $fileName == '403.shtml') {
        $fileName = 'index';
    }

    $cacheKey = str_replace('/', '-', trim($fileName, '/'));

    return $cacheKey ?: 'index';
}

/**
 * Grab the content from the prerender
 *
 * @see https://stackoverflow.com/a/42245266/3380387
 * @return void
 */
function load_content()
{
    global $file_path;

    $domain = $_GET['domain'];

    $delay = $_GET['delay'];
    
    $path = path();

    $content = get_content("https://prerender.mentoor.io?domain=$domain&path=/$path&delay=$delay");

    cache($content);

    file_put_contents($file_path, $content);

    echo $content;

    die;
}

function get_content($URL)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

    curl_setopt($ch, CURLOPT_URL, $URL);
    $data = curl_exec($ch);

    curl_close($ch);
    return $data;
}